*** WeiDU-185/src/automate.ml	Fri Jan 14 05:30:59 2005
--- WeiDU/src/automate.ml	Tue Nov 11 01:20:58 2008
***************
*** 2,32 ****
   * directory *)
  open Util
  
! 
! let automate game dir_l min o =
! 
    let consider buff off off_name = 
      let i = int_of_str_off buff off in 
      if (i > min) && (i > 0) && 
          (i <= Array.length game.Load.dialog) then begin
        let male = Tlk.pretty_print game.Load.dialog i in
        let female = Tlk.pretty_print_opt game.Load.dialogf i in 
!       Printf.fprintf o "  SAY %s %s %s\n" 
!         off_name  male female 
      end
    in 
- 
-   let process file small = 
      let _,ext = split file in
      let ext = String.uppercase ext in 
-     let src = Printf.sprintf "~%s~" file in
-     let dst = Printf.sprintf "~override/%s~" small in 
      try begin
      match ext with 
      | "SPL" 
      | "ITM" 
      | "CRE" -> begin
-         Printf.fprintf o "\nCOPY %-30s %-30s\n" src dst ; 
            let buff = load_file file in 
            consider buff 0x8 "NAME1" ;
            consider buff 0xc "NAME2" ;
--- 2,25 ----
   * directory *)
  open Util
  
!   let process file game min o =
    let consider buff off off_name =
      let i = int_of_str_off buff off in 
      if (i > min) && (i > 0) && 
          (i <= Array.length game.Load.dialog) then begin
        let male = Tlk.pretty_print game.Load.dialog i in
        let female = Tlk.pretty_print_opt game.Load.dialogf i in
!       o (Printf.sprintf "  SAY %s %s %s\n" 
!         off_name  male female)
      end
    in
      let _,ext = split file in
      let ext = String.uppercase ext in
      try begin
      match ext with 
      | "SPL"
      | "ITM" 
      | "CRE" -> begin
            let buff = load_file file in
            consider buff 0x8 "NAME1" ;
            consider buff 0xc "NAME2" ;
***************
*** 53,60 ****
              done ;
            end 
          end 
      | "ARE" -> begin
-         Printf.fprintf o "\nCOPY %-30s %-30s\n" src dst ; 
            begin 
            let buff = load_file file in 
            let signature = String.sub buff 0 8 in 
--- 46,61 ----
              done ;
            end 
          end
+     | "EFF" -> begin
+         let buff = load_file file in
+         let eff_list = Load.eff_of_eff buff in
+         Array.iter (fun eff ->
+           if eff.Load.opcode = 139 (* display string *) then
+             let offset = eff.Load.raw_offset + 0x1c in
+             consider buff offset (Printf.sprintf "0x%x" offset)
+         ) eff_list
+         end
      | "ARE" -> begin
            begin
            let buff = load_file file in
            let signature = String.sub buff 0 8 in
***************
*** 65,71 ****
            | "AREAV9.1" -> 
                  (short_of_str_off buff 0x6a , int_of_str_off buff 0x6c )
            | _ -> 
!             Printf.fprintf o "  // %s files not supported\n" signature ;
              (0, 0)
            in 
            for i = 0 to (num_info_points - 1) do 
--- 66,72 ----
            | "AREAV9.1" ->
                  (short_of_str_off buff 0x6a , int_of_str_off buff 0x6c )
            | _ ->
!             o (Printf.sprintf "  // %s files not supported\n" signature) ;
              (0, 0)
            in
            for i = 0 to (num_info_points - 1) do
***************
*** 76,82 ****
            end 
          end 
      | "STO" -> begin
-         Printf.fprintf o "\nCOPY %-30s %-30s\n" src dst;
          let buff = load_file file in
          consider buff 0xc "NAME2";
          end
--- 77,82 ----
***************
*** 85,101 ****
            log_and_print "Error automating [%s] : %s \n" file
            (Printexc.to_string e)
            end 
-   in 
  
    List.iter (fun dir ->
!     if (Unix.stat dir).Unix.st_kind <> Unix.S_REG then begin
!       let d_h = Unix.opendir dir in
        try
          while true do 
!           let s' = Unix.readdir d_h in
!           let full = dir ^ "/" ^ s' in 
!           if file_size full > 0 then
!             process full s' 
          done 
        with e -> (Unix.closedir d_h ) 
      end 
--- 85,108 ----
            log_and_print "Error automating [%s] : %s \n" file
            (Printexc.to_string e)
            end 
  
+ let automate_file game file_name min o =
+ 	process file_name game min o
+ 
+ let automate game dir_l min o =
    List.iter (fun dir ->
!     if (Case_ins.unix_stat dir).Unix.st_kind <> Unix.S_REG then begin
!       let d_h = Case_ins.unix_opendir dir in
        try
          while true do 
!           let s = Unix.readdir d_h in
!           let full = dir ^ "/" ^ s in 
!           if file_size full > 0 then begin
! 				    let src = Printf.sprintf "~%s~" full in
! 				    let dst = Printf.sprintf "~override/%s~" s in
! 		        o (Printf.sprintf "\nCOPY %-30s %-30s\n" src dst) ;
!             process full game min o
!           end
          done 
        with e -> (Unix.closedir d_h ) 
      end 
