*** WeiDU-185/src/bafparser.mly	Fri Aug 20 15:41:12 2004
--- WeiDU/src/bafparser.mly	Wed May 14 23:03:50 2008
***************
*** 4,9 ****
--- 4,18 ----
  open Bcs
  open Load
  
+ (* Note added due to LGPL terms.
+ 
+ This file was edited by Valerio Bigiani, AKA The Bigg, starting from
+ 6 November 2005. All changes for this file are listed in
+ diffs/src.bafparser.mly.diff file, as the output of a diff -Bw -c -N command.
+ 
+ It was originally taken from Westley Weimer's WeiDU 185. *)
+ 
+ 
  (*** input handle ***)
  
  (*** Error handling ***)
***************
*** 14,19 ****
--- 23,29 ----
  | BA_String of string
  | BA_Bracket of bracket_arg list
  | BA_Compound of string * bafarg
+ | BA_Rect of bafarg * (Int32.t * Int32.t * Int32.t * Int32.t) option
  and bracket_arg =
    Bracket_Integer of Int32.t
  | Bracket_Symbol of string
***************
*** 49,64 ****
--- 59,84 ----
      Act_Point i -> i
    | _ -> failwith "get_next_point"
  
+ let valid_var_area s =
+   let s = String.uppercase s in
+   if !debug_ocaml then log_and_print "valid_var_area %s\n" s;
+   let ans = (s = "GLOBAL" || s = "LOCALS" || s = "KAPUTZ" || s = "MYAREA" || s = "" ||
+   ( Str.string_match (Str.regexp "AR[0-9][0-9][0-9][0-9]") s 0) || file_exists_in_game (the_game ()) (s ^ ".ARE")) in
+   ans
+ 
  let fixup_concat argl =
    let s1 = get_next_string argl in
    let s2 = get_next_string argl in
+   if not (valid_var_area s2) then Modder.handle_deb "AREA_VARIABLES" (Printf.sprintf "This expression has a typo in the second part: Global(\"%s\",\"%s\")\n" s1 s2);
    argl := (Arg_String,Act_String(s2^s1)) :: !argl
  
  let fixup_concat2 argl =
    let s1 = get_next_string argl in
    let s2 = get_next_string argl in
+   if not (valid_var_area s2) then Modder.handle_deb "AREA_VARIABLES" (Printf.sprintf "This expression has a typo in the second part: *Global*(\"%s\",\"%s\")\n" s1 s2);
    let s3 = get_next_string argl in
    let s4 = get_next_string argl in
+   if not (valid_var_area s4) then Modder.handle_deb "AREA_VARIABLES" (Printf.sprintf "This expression has a typo in the second part: *Global*(\"%s\",\"%s\")\n" s3 s4);
    argl := (Arg_String,Act_String(s2^s1)) ::
            (Arg_String,Act_String(s4^s3)) :: !argl
  
***************
*** 68,85 ****
    | Load.IWD2,1 -> obj.o_general <- x
    | Load.IWD2,2 -> obj.o_race <- x
    | Load.IWD2,3 -> obj.o_subrace <- x
!   | Load.IWD2,4 -> obj.o_class <- x
!   | Load.IWD2,5 -> obj.o_specific <- x
!   | Load.IWD2,6 -> obj.o_gender <- x
!   | Load.IWD2,7 -> obj.o_alignment <- x
! 
!   | Load.BG,0 -> obj.o_ea <- x 
!   | Load.BG,1 -> obj.o_general <- x
!   | Load.BG,2 -> obj.o_race <- x
!   | Load.BG,3 -> obj.o_class <- x
!   | Load.BG,4 -> obj.o_specific <- x
!   | Load.BG,5 -> obj.o_gender <- x
!   | Load.BG,6 -> obj.o_alignment <- x
  
    | Load.PST,0 -> obj.o_ea <- x 
    | Load.PST,1 -> obj.o_faction <- x 
--- 88,123 ----
    | Load.IWD2,1 -> obj.o_general <- x
    | Load.IWD2,2 -> obj.o_race <- x
    | Load.IWD2,3 -> obj.o_subrace <- x
!   | Load.IWD2,4 -> obj.o_specific <- x
!   | Load.IWD2,5 -> obj.o_gender <- x
!   | Load.IWD2,6 -> obj.o_alignment <- x
!   | Load.IWD2,7 -> obj.o_class <- x
!   | Load.IWD2,8 -> obj.o_iwd2_1 <- x
!   | Load.IWD2,9 -> obj.o_iwd2_2 <- x
! 
!   | Load.IWD1,0 -> obj.o_ea <- x
!   | Load.IWD1,1 -> obj.o_general <- x
!   | Load.IWD1,2 -> obj.o_race <- x
!   | Load.IWD1,3 -> obj.o_class <- x
!   | Load.IWD1,4 -> obj.o_specific <- x
!   | Load.IWD1,5 -> obj.o_gender <- x
!   | Load.IWD1,6 -> obj.o_alignment <- x
! 
!   | Load.BG1,0 -> obj.o_ea <- x
!   | Load.BG1,1 -> obj.o_general <- x
!   | Load.BG1,2 -> obj.o_race <- x
!   | Load.BG1,3 -> obj.o_class <- x
!   | Load.BG1,4 -> obj.o_specific <- x
!   | Load.BG1,5 -> obj.o_gender <- x
!   | Load.BG1,6 -> obj.o_alignment <- x
! 
!   | Load.BG2,0 -> obj.o_ea <- x
!   | Load.BG2,1 -> obj.o_general <- x
!   | Load.BG2,2 -> obj.o_race <- x
!   | Load.BG2,3 -> obj.o_class <- x
!   | Load.BG2,4 -> obj.o_specific <- x
!   | Load.BG2,5 -> obj.o_gender <- x
!   | Load.BG2,6 -> obj.o_alignment <- x
  
    | Load.PST,0 -> obj.o_ea <- x
    | Load.PST,1 -> obj.o_faction <- x
***************
*** 91,97 ****
    | Load.PST,7 -> obj.o_gender <- x
    | Load.PST,8 -> obj.o_alignment <- x
  
!   | _ -> failwith "assign to unknown bracket position"
  
  let assign_compound x pos obj = match pos with
    | 0 -> obj.o_unknown4 <- x
--- 129,135 ----
    | Load.PST,7 -> obj.o_gender <- x
    | Load.PST,8 -> obj.o_alignment <- x
  
!   | _ -> failwith (Printf.sprintf "assign %d to unknown bracket position %d" (Int32.to_int x) pos)
  
  let assign_compound x pos obj = match pos with
    | 0 -> obj.o_unknown4 <- x
***************
*** 121,126 ****
--- 159,169 ----
        end
  
  let rec handle_compound_or_bracket obj cpos_ref arg = match arg with
+   BA_Rect (arg,rect) ->
+ 			handle_compound_or_bracket obj cpos_ref arg;
+ 			(match rect with
+ 			| None -> ()
+ 			| Some(x) -> obj.o_rect <- x);
    | BA_Bracket l -> 
        handle_bracket_list l 0 obj  
    | BA_Compound (s,next_arg) -> 
***************
*** 149,155 ****
    with _ -> [] ) 
    | (ah::at),(fh::ft) -> 
        begin 
!       let act = (match ah,fh.arg_kind with
        | (BA_Integer i), Arg_Integer -> Act_Integer(i)
  
  
--- 192,202 ----
    with _ -> [] )
    | (ah::at),(fh::ft) -> 
        begin 
!       let ah' = match ah with
!       |	BA_Rect(f,s) -> f
!       |	_ -> ah
!       in
!       let act = (match ah',fh.arg_kind with
        | (BA_Integer i), Arg_Integer -> Act_Integer(i)
  
  
***************
*** 209,215 ****
  
  %token LPAREN RPAREN LBRACKET RBRACKET PERIOD COMMA
  %token ACTIONOVERRIDE
- %token HASH 
  %token NOT EOF
  %token IF THEN END RESPONSE EOF ANYONE
  %nonassoc NOT 
--- 257,262 ----
***************
*** 276,287 ****
  | LBRACKET SYMBOL RBRACKET { $2 } 
  ; 
  
! arg : SYMBOL opt_arg 
!                 { match $2 with 
                      None -> BA_Symbol($1) 
!                   | Some(a) -> BA_Compound($1,a) }
! | INTEGER       { BA_Integer($1) }
! | STRING        { BA_String($1) }
  | TILDE_STRING sound_opt 
    { let result = Dlg.Local_String({ lse_male = $1 ; lse_male_sound = $2; 
                      lse_female = $1; lse_female_sound = $2;}) in 
--- 323,337 ----
  | LBRACKET SYMBOL RBRACKET { $2 } 
  ; 
  
! rect_opt :																															 { None }
! | LBRACKET INTEGER PERIOD INTEGER PERIOD INTEGER PERIOD INTEGER RBRACKET { Some($2,$4,$6,$8) }
! ;
! 
! arg : | SYMBOL opt_arg rect_opt { BA_Rect((match $2 with
                      None -> BA_Symbol($1) 
!                   | Some(a) -> BA_Compound($1,a)),$3) }
! | INTEGER rect_opt { BA_Rect(BA_Integer($1),$2) }
! | STRING rect_opt { BA_Rect(BA_String($1),$2) }
  | TILDE_STRING sound_opt 
    { let result = Dlg.Local_String({ lse_male = $1 ; lse_male_sound = $2; 
                      lse_female = $1; lse_female_sound = $2;}) in 
***************
*** 311,319 ****
  | TRANS_REF 
    { match Dc.resolve_string_while_loading (Dlg.Trans_String(Int32.to_int $1))
      with Dlg.TLK_Index(i) -> BA_Integer(Int32.of_int i)
!     | _ -> parse_error (Printf.sprintf "unable to resolve translation string @%ld" $1)
    } 
! | LBRACKET ba_arg_list RBRACKET { BA_Bracket($2) }
  ;
  
  opt_arg :       { None }
--- 361,369 ----
  | TRANS_REF 
    { match Dc.resolve_string_while_loading  (Dlg.Trans_String(Int32.to_int $1))
      with Dlg.TLK_Index(i) -> BA_Integer(Int32.of_int i)
!     | _ -> if not !Dc.doing_traify then parse_error (Printf.sprintf "unable to resolve translation string @%ld" $1) else BA_Integer(Int32.of_int 1)
    }
! | LBRACKET ba_arg_list RBRACKET rect_opt { BA_Rect(BA_Bracket($2),$4) }
  ;
  
  opt_arg :       { None }
***************
*** 342,348 ****
  | response response_list { $1 :: $2 }
  ;
  
! response : RESPONSE HASH INTEGER action_list { ((Int32.to_int $3),$4) }
  ;
  
  action_list :     { [] }
--- 392,398 ----
  | response response_list { $1 :: $2 }
  ;
  
! response : RESPONSE INTEGER action_list { ((Int32.to_int $2),$3) }
  ;
  
  action_list :     { [] }
