*** WeiDU-185/src/diff.ml	Thu Feb 26 21:45:38 2004
--- WeiDU/src/diff.ml	Mon Nov  3 21:00:35 2008
***************
*** 9,15 ****
--- 9,25 ----
     of chunks that couldn't be applied is returned in bad_chunks.
     The number of chunks that are already applied is returned in app_chunks.
   *)
+ 
+ let fixdouble s =
+ 	Str.global_replace (Str.regexp "\r") "" s
+ 
+ let fixnl s =
+ 	let s = fixdouble s in
+ 	if s.[String.length s - 1] = '\n' then s else s ^ "\n"
+ 
  let do_patch orig_buff patch_buff vb = begin
+ 		let orig_buff = fixnl orig_buff in
+ 	  let patch_buff = fixnl patch_buff in
    let newf, rejf = Xdiff.patch orig_buff patch_buff in begin
      (* RE which deliminates rejected chunks from patch *)
      let delimre = Str.regexp "@@ -[0-9]+,[0-9]+ \\+[0-9]+,[0-9]+ @@" in
***************
*** 42,62 ****
                raise Not_found)
      in
      check_chunk rej_chunks;
      (newf, !bad_chunks, !app_chunks) ;
    end
  end
  
! (* Usage: create_patch orig_buff new_buff out_name ncont
!    
!    Creates a patch by comparing orig_buff and new_buff and
!    writes the patch to file out_name.
!  *)
! let create_patch orig_buff new_buff out_name ncont = begin
    try
!     let out_chan = open_for_writing out_name true in
!     let patch_buff = Xdiff.diff orig_buff new_buff ncont in
!     let _ = output_string out_chan patch_buff in
!     close_out out_chan
    with e -> begin
      log_and_print "create_patch: couldn't create patch: %s\n" (Printexc.to_string e);
      raise Not_found
--- 52,69 ----
                raise Not_found)
      in
      check_chunk rej_chunks;
+     if !bad_chunks > 0 then begin
+     	log_and_print "The following patch:\n\n%s\n\nfailed on the following text:\n\n%s\n\n" patch_buff orig_buff
+     end;
      (newf, !bad_chunks, !app_chunks) ;
    end
  end
  
! let get_patch orig_buff new_buff ncont =begin
! 		let orig_buff = fixnl orig_buff in
! 		let new_buff = fixnl new_buff in
    try
!     fixdouble (Xdiff.diff orig_buff new_buff ncont)
    with e -> begin
      log_and_print "create_patch: couldn't create patch: %s\n" (Printexc.to_string e);
      raise Not_found
