*** WeiDU-185/src/load.ml	Wed May 18 22:08:28 2005
--- WeiDU/src/load.ml	Sat Dec 13 15:16:18 2008
***************
*** 1,22 ****
  open Util
  
  let registry_game_paths () = 
    let str_list = "." :: !Arch.registry_paths in 
    List.map (fun str -> 
!     if str = "." then str else Filename.dirname str 
    ) str_list 
  
  let game_paths = ref [] 
  
! let add_game_path path = game_paths := path :: !game_paths
  
  let override_paths = ref [
    (* compton wants this gone *)
    (* "." ; *)
  ] 
  
  let allow_missing = ref [] 
  
  let ok_missing file =
    let file = String.uppercase file in 
    let rec check lst = match lst with 
--- 1,36 ----
+ (* Note added due to LGPL terms.
+ 
+ This file was edited by Valerio Bigiani, AKA The Bigg, starting from
+ 1 January 2006, according to FredSRichardson's diffs. All changes for 
+ this file are listed in diffs/src.load.ml.diff file, as the output 
+ of a diff -Bw -c -N command.
+ 
+ It was originally taken from Westley Weimer's WeiDU 185. *)
+ 
  open Util
+ open Cbif
  
  let registry_game_paths () = 
    let str_list = "." :: !Arch.registry_paths in 
    List.map (fun str -> 
!     if str = "." then str else Case_ins.filename_dirname str 
    ) str_list 
  
  let game_paths = ref [] 
  
! let add_game_path path = game_paths := (Str.global_replace (Str.regexp "[\\\\/]*$") "" path) :: !game_paths
  
  let override_paths = ref [
    (* compton wants this gone *)
    (* "." ; *)
  ]
  
+ let ids_paths = ref []
+ 
  let allow_missing = ref []
  
+ let cbifs_to_rem = Queue.create ()
+ 
  let ok_missing file =
    let file = String.uppercase file in
    let rec check lst = match lst with
***************
*** 26,31 ****
--- 40,46 ----
    in check !allow_missing
  
  let add_override_path path = override_paths := !override_paths @ [path]
+ let add_ids_path path = ids_paths := !ids_paths @ [path]
  
  let dialog_tlk_path = ref None
  let dialogf_tlk_path = ref None
***************
*** 36,48 ****
  (* old index, old value, old female value *)
  type str_set_record = (int * Tlk.tlk_string * Tlk.tlk_string)
  
! type script_style = BG | IWD2 | PST 
  
  type game = {
!           key          : Key.key ;
            game_path    : string ; 
            cd_path_list : string list ; 
    mutable override_path_list : string list ; 
    mutable loaded_biffs : (string, Biff.biff) Hashtbl.t ;
    mutable dialog       : Tlk.tlk ;
    mutable dialog_search : (string, int) Hashtbl.t ;
--- 51,64 ----
  (* old index, old value, old female value *)
  type str_set_record = (int * Tlk.tlk_string * Tlk.tlk_string)
  
! type script_style = BG1 | BG2 | IWD1 | IWD2 | PST | NONE
  
  type game = {
!   mutable key          : Key.key ;
            game_path    : string ;
            cd_path_list : string list ;
    mutable override_path_list : string list ;
+   mutable ids_path_list : string list ;
    mutable loaded_biffs : (string, Biff.biff) Hashtbl.t ;
    mutable dialog       : Tlk.tlk ;
    mutable dialog_search : (string, int) Hashtbl.t ;
***************
*** 53,58 ****
--- 69,75 ----
            dialogf_path : string ;
    mutable dialog_mod   : bool ; (* changed? *)
    mutable dialogf_mod  : bool ; (* changed? *)
+   mutable key_mod      : bool ; (* changed? *)
    mutable script_style : script_style ; 
  } 
  
***************
*** 124,129 ****
--- 141,147 ----
      game_path = " -- NO GAME -- " ;
      cd_path_list = [] ; 
      override_path_list = !override_paths ;
+     ids_path_list = !ids_paths ;
      loaded_biffs = Hashtbl.create 1 ;
      dialog = d ; 
      dialog_search = Hashtbl.create (1 + ((Array.length d) * 2)) ;
***************
*** 133,139 ****
      dialogf_path = " -- NO DIALOGF.TLK -- " ;
      dialog_mod = false ;
      dialogf_mod = false ;
!     script_style = BG ; 
    } in
    create_dialog_search result ;
    result 
--- 151,158 ----
      dialogf_path = " -- NO DIALOGF.TLK -- " ;
      dialog_mod = false ;
      dialogf_mod = false ;
!     key_mod = false ;
!     script_style = BG2 ;
    } in
    create_dialog_search result ;
    result 
***************
*** 143,149 ****
  let find_file_in_path path file =
    try 
    begin
!     let h = Unix.opendir path in
      let regexp = Str.regexp_case_fold file in 
      let res = ref None in  
      ( try
--- 162,168 ----
  let find_file_in_path path file =
    try
    begin
!     let h = Case_ins.unix_opendir path in
      let regexp = Str.regexp_case_fold file in 
      let res = ref None in  
      ( try
***************
*** 191,197 ****
    in
    let cd_paths = 
    try 
!     let s_d_h = Unix.opendir gp in
      let sofar = ref [] in 
      begin
      try 
--- 209,215 ----
    in
    let cd_paths =
    try
!     let s_d_h = Case_ins.unix_opendir gp in
      let sofar = ref [] in
      begin
      try
***************
*** 219,224 ****
--- 237,243 ----
      !sofar
    with _ -> [ gp ^ "/CD1" ; gp ^ "/CD2" ; gp ^ "/CD3" ;
                gp ^ "/CD4" ; gp ^ "/CD5" ; gp ^ "/CD6" ] in
+   let cd_paths = if Sys.os_type = "Unix" then cd_paths @ [ gp ^ "/CD1" ; gp ^ "/CD2" ; gp ^ "/CD3" ; gp ^ "/CD4" ; gp ^ "/CD5" ; gp ^ "/CD6" ] else cd_paths in
    let df_path = match !dialogf_tlk_path with
      Some(p) -> p
    | None -> find_file_in_path gp "dialogf.tlk"
***************
*** 236,241 ****
--- 255,261 ----
      game_path = gp ;
      cd_path_list = cd_paths ;
      override_path_list = !override_paths @ [ (gp ^ "/override") ] ;
+     ids_path_list = !ids_paths @ !override_paths @ [ (gp ^ "/override") ];
      loaded_biffs = Hashtbl.create 5 ;
      dialog = dialog_tlk ;
      dialog_search = Hashtbl.create ((Array.length dialog_tlk) * 2) ;
***************
*** 245,259 ****
      dialogf_path = dialogf_path ;
      dialog_mod = false ;
      dialogf_mod = false ;
      script_style = 
        begin
          try 
!           let _ = Key.find_resource key "SUBRACE" "IDS" in IWD2
          with Not_found -> 
            begin
              try 
!               let _ = Key.find_resource key "FACTION" "IDS" in PST
!             with Not_found -> BG
            end 
        end 
    } in
--- 265,288 ----
      dialogf_path = dialogf_path ;
      dialog_mod = false ;
      dialogf_mod = false ;
+     key_mod = false ;
      script_style =
        begin
          try
!           let _ = Key.find_resource key "SUBRACE" "IDS" in (Tlk.is_bg2 := false;IWD2)
          with Not_found ->
            begin
              try
!               let _ = Key.find_resource key "BONES" "IDS" in (Tlk.is_bg2 := false;PST)
!             with Not_found ->
!               begin
!                 try
!                   let _ = Key.find_resource key "CLOWNRAN" "IDS" in (Tlk.is_bg2 := false;IWD1)
!                 with Not_found -> 
! 									try
! 										let _ = Key.find_resource key "FLYTHR01" "MVE" in(Tlk.is_bg2 := true; BG2)
! 									with Not_found -> (Tlk.is_bg2 := false;BG1)
!               end
            end
        end
    } in
***************
*** 290,308 ****
        Hashtbl.find game.loaded_biffs bif_file (* already here *)
      else begin
        (* we must load the BIF *)
!       let biff_path = 
!         let rec trial lst =
            match lst with
!             [] -> find_file_in_path game.game_path bif_file 
            | hd :: tl ->
!             let perhaps = find_file_in_path hd bif_file in 
              log_only "BIFF may be in hard-drive CD-path [%s]\n" perhaps ; 
              if file_exists perhaps then 
                perhaps
!             else trial tl 
!         in
!         trial (game.cd_path_list)
        in
        let the_biff = Biff.load_biff biff_path in
        Hashtbl.add game.loaded_biffs bif_file the_biff ;
        the_biff
--- 319,352 ----
        Hashtbl.find game.loaded_biffs bif_file (* already here *)
      else begin
        (* we must load the BIF *)
!       let biff_path = begin
!         let rec trial f lst =
            match lst with
!             [] -> find_file_in_path game.game_path f
            | hd :: tl ->
!               let perhaps = find_file_in_path hd f in
              log_only "BIFF may be in hard-drive CD-path [%s]\n" perhaps ; 
              if file_exists perhaps then 
                perhaps
!               else trial f tl
        in
+         (* Check to see if the bif file exists, if it doesn't try for a .CBF file *)
+         let bf = trial bif_file (game.cd_path_list @ [ game.game_path ^ "/cache" ] ) in
+         if file_exists bf then
+           bf
+         else begin
+           let cbf = Case_ins.filename_chop_extension bif_file ^ ".cbf" in
+           let cbf_file = trial cbf (game.cd_path_list) in
+           if file_exists cbf_file then
+             let cache_file = game.game_path ^ "/cache/" ^ bif_file in
+             if not (file_exists cache_file) then Queue.add cache_file cbifs_to_rem;
+             let sz = Cbif.cbf2bif cbf_file cache_file in
+             let _ = log_and_print "[%s] decompressed bif file %d bytes\n" cbf_file sz in
+             cache_file
+           else
+             bf
+         end
+       end in
        let the_biff = Biff.load_biff biff_path in
        Hashtbl.add game.loaded_biffs bif_file the_biff ;
        the_biff
***************
*** 327,333 ****
    let ext_up = String.uppercase ext in 
    let full = name ^ "." ^ ext in 
    let a,b = 
!   if (Filename.is_implicit name) then begin
      try 
        (* first, try all of the overrides *)
        if override_allowed then 
--- 371,377 ----
    let ext_up = String.uppercase ext in
    let full = name ^ "." ^ ext in
    let a,b =
!   if (Case_ins.filename_is_implicit name) then begin
      try
        (* first, try all of the overrides *)
        if override_allowed then
***************
*** 335,352 ****
            let path = op ^ "/" ^ full in
            if file_exists path then 
              raise (FoundRes(load_file path, path))
!         ) game.override_path_list ;
  
        (* Now get it from the BIFs -- look it up in the KEY *)
        let bif_file, bif_index, tis_index, this_biff = 
          find_in_key game name ext in 
        (* get it out of the BIF *)
        if ext_up = "TIS" then 
!         (Biff.extract_tis this_biff (tis_index-1)),(game.game_path ^ "/" ^ bif_file)
        else 
!         (Biff.extract_file this_biff bif_index),(game.game_path ^ "/" ^ bif_file)
      with 
!     | Not_found -> 
        if ok_missing (name ^ "." ^ ext) then 
          "","(resource not found)" 
        else begin
--- 379,398 ----
            let path = op ^ "/" ^ full in
            if file_exists path then
              raise (FoundRes(load_file path, path))
!         ) (if ext_up = "IDS" then game.ids_path_list else game.override_path_list) ;
  
        (* Now get it from the BIFs -- look it up in the KEY *)
        let bif_file, bif_index, tis_index, this_biff =
          find_in_key game name ext in
        (* get it out of the BIF *)
        if ext_up = "TIS" then
!         (Biff.extract_tis this_biff (tis_index-1)) skip_this_error,(game.game_path ^ "/" ^ bif_file)
        else
!         (Biff.extract_file this_biff bif_index) skip_this_error,(game.game_path ^ "/" ^ bif_file)
      with
!     | (FoundRes(b,p)) -> b,p
!     | Invalid_argument "String.create" -> raise (Invalid_argument "String.create")
!     | _ ->
        if ok_missing (name ^ "." ^ ext) then
          "","(resource not found)"
        else begin
***************
*** 363,369 ****
            name ext for_what)
          end
        end 
-     | (FoundRes(b,p)) -> b,p
    end else 
      (load_file full), full
    in 
--- 409,414 ----
***************
*** 427,436 ****
  (*
  
  let search_biff_contents_eff game o tl =
!   let key_list = List.map (fun ext -> Key.key_of_ext ext) tl in 
    Array.iter (fun r ->
      let biff = game.key.biff.(r.bif_index) in
!     if List.mem r.res_type key_list then begin (* type match *)
        try 
        let buff,path = 
          load_resource game true r.res_name (ext_of_key r.res_type) in
--- 472,481 ----
  (*
  
  let search_biff_contents_eff game o tl =
!   let key_list = List.map (fun ext -> Key.key_of_ext true ext) tl in 
    Array.iter (fun r ->
      let biff = game.key.biff.(r.bif_index) in
!     if List.mem r.res_type key_list then begin
        try 
        let buff,path = 
          load_resource game true r.res_name (ext_of_key r.res_type) in
***************
*** 455,465 ****
    ) game.key.resource 
  
  let search_biff_contents_all game o tl sl =
!   let key_list = List.map (fun ext -> Key.key_of_ext ext) tl in 
    let reg_list = List.map (fun s -> Str.regexp_case_fold s, s) sl in 
    Array.iter (fun r ->
      let biff = game.key.biff.(r.bif_index) in
!     if List.mem r.res_type key_list then begin (* type match *)
        try 
        let has = ref [] in 
        let buff,path = 
--- 500,510 ----
    ) game.key.resource 
  
  let search_biff_contents_all game o tl sl =
!   let key_list = List.map (fun ext -> Key.key_of_ext true ext) tl in 
    let reg_list = List.map (fun s -> Str.regexp_case_fold s, s) sl in 
    Array.iter (fun r ->
      let biff = game.key.biff.(r.bif_index) in
!     if List.mem r.res_type key_list then begin 
        try 
        let has = ref [] in 
        let buff,path = 
***************
*** 485,491 ****
  let content_name_offset = ref None 
  
  let search_biff_contents game o tl sl =
!   let key_list = List.map (fun ext -> Key.key_of_ext ext) tl in 
    let reg_list = List.map Str.regexp_case_fold sl in 
    Array.iter (fun r ->
      let biff = game.key.biff.(r.bif_index) in
--- 530,536 ----
  let content_name_offset = ref None 
  
  let search_biff_contents game o tl sl =
!   let key_list = List.map (fun ext -> Key.key_of_ext true ext) tl in 
    let reg_list = List.map Str.regexp_case_fold sl in 
    Array.iter (fun r ->
      let biff = game.key.biff.(r.bif_index) in
***************
*** 504,521 ****
          match !content_name_offset with
          | Some(off) when String.length buff >= off + 4 -> 
              let name_id = int_of_str_off buff off in 
!             Printf.fprintf o "%8s.%3s in [%s] matches [%s]\n"
!               r.res_name ( ext_of_key r.res_type ) biff.filename 
!               (Tlk.pretty_print game.dialog name_id)
!         | _ -> Printf.fprintf o "%8s.%3s in [%s] matches\n"
              r.res_name ( ext_of_key r.res_type ) biff.filename 
        end 
        with e -> ()
      end  ;
    ) game.key.resource 
  
  let search_biff_contents_fun game o tl matches =
!   let key_list = List.map (fun ext -> Key.key_of_ext ext) tl in 
    Array.iter (fun r ->
      let biff = game.key.biff.(r.bif_index) in
      if List.mem r.res_type key_list then begin (* type match *)
--- 549,566 ----
          match !content_name_offset with
          | Some(off) when String.length buff >= off + 4 -> 
              let name_id = int_of_str_off buff off in 
!             o (Printf.sprintf "%8s.%3s in [%s] matches [%s]\n"
                r.res_name ( ext_of_key r.res_type ) biff.filename 
+               (Tlk.pretty_print game.dialog name_id))
+         | _ -> o (Printf.sprintf "%8s.%3s in [%s] matches\n"
+             r.res_name ( ext_of_key r.res_type ) biff.filename)
        end 
        with e -> ()
      end  ;
    ) game.key.resource 
  
  let search_biff_contents_fun game o tl matches =
!   let key_list = List.map (fun ext -> Key.key_of_ext true ext) tl in 
    Array.iter (fun r ->
      let biff = game.key.biff.(r.bif_index) in
      if List.mem r.res_type key_list then begin (* type match *)
***************
*** 525,536 ****
          match !content_name_offset with
          | Some(off) when String.length buff >= off + 4 -> 
              let name_id = int_of_str_off buff off in 
!             Printf.fprintf o "%8s.%3s in [%s] matches [%s]\n"
!               r.res_name ( ext_of_key r.res_type ) biff.filename 
!               (Tlk.pretty_print game.dialog name_id)
!         | _ -> Printf.fprintf o "%8s.%3s in [%s] matches\n"
              r.res_name ( ext_of_key r.res_type ) biff.filename 
        end 
        with e -> ()
      end  ;
    ) game.key.resource 
--- 570,595 ----
          match !content_name_offset with
          | Some(off) when String.length buff >= off + 4 -> 
              let name_id = int_of_str_off buff off in 
!             o (Printf.sprintf "%8s.%3s in [%s] matches [%s]\n"
                r.res_name ( ext_of_key r.res_type ) biff.filename 
+               (Tlk.pretty_print game.dialog name_id))
+         | _ -> o (Printf.sprintf "%8s.%3s in [%s] matches\n"
+             r.res_name ( ext_of_key r.res_type ) biff.filename)
        end 
        with e -> ()
      end  ;
    ) game.key.resource 
+ 
+ let file_exists_in_game game f =
+   let old_allow_missing = !allow_missing in
+   allow_missing := [] ;
+   let res =
+   (try
+     let a,b = split f in
+     skip_next_load_error := true;
+     let buff,path = load_resource "FILE_EXISTS_IN_GAME" game true a b in
+       (String.length buff > 0)
+   with _ -> false ) in
+   allow_missing := old_allow_missing ;
+   res
+ 
