*** WeiDU-185/src/tlk.ml	Sat Feb  5 19:57:37 2005
--- WeiDU/src/tlk.ml	Sun Jun  1 00:16:48 2008
***************
*** 1,7 ****
  (* Infinity Engine [TLK] Format *)
  open Util
  
! let flags_parse = 7 
  
  type tlk_string = {
    mutable flags : int; 
--- 1,9 ----
  (* Infinity Engine [TLK] Format *)
  open Util
  
! (* let flags_parse = 7  *)
! 
! let is_bg2 = ref false
  
  type tlk_string = {
    mutable flags : int; 
***************
*** 101,107 ****
  
  let load_big_slow_tlk filename = begin
    Stats.time "unmarshal TLK" (fun () -> 
!   let fd = Unix.openfile filename [Unix.O_RDONLY] 0 in 
    let buff = String.create 8 in 
    my_read 8 fd buff filename ; 
    if buff <> "TLK V1  " then begin
--- 103,109 ----
  
  let load_big_slow_tlk filename = begin
    Stats.time "unmarshal TLK" (fun () -> 
!   let fd = Case_ins.unix_openfile filename [Unix.O_RDONLY] 0 in 
    let buff = String.create 8 in 
    my_read 8 fd buff filename ; 
    if buff <> "TLK V1  " then begin
***************
*** 229,235 ****
  end
  
  let load_tlk filename = 
!   let stats = Unix.stat filename in
    let size = stats.Unix.st_size in 
    if (size < 8) then
      failwith "not a valid TLK file (too small)"
--- 231,237 ----
  end
  
  let load_tlk filename = 
!   let stats = Case_ins.unix_stat filename in
    let size = stats.Unix.st_size in 
    if (size < 8) then
      failwith "not a valid TLK file (too small)"
***************
*** 274,328 ****
    () 
  end
  
- (*
- let save_tlk filename tlk outchan = begin
-   let num = Array.length tlk in 
-   let header_buff = Buffer.create 18 in
-   let entries_buff = Buffer.create (num * 26) in
-   let string_buff = Buffer.create (num * 200) in  
-   (* actual average string entry length is about 125 in English/Ascension *)
-   Stats.time "marshal TLK" (fun () -> 
-   Buffer.add_string header_buff "TLK V1  " ;
-   Buffer.add_char header_buff '\000' ;
-   Buffer.add_char header_buff '\000' ;
-   Buffer.add_string header_buff (str_of_int num) ;
-   let offset_strdata = 18 + (num * 26) in 
-   Buffer.add_string header_buff (str_of_int offset_strdata) ; 
- 
-   for i = 0 to num - 1 do
-     Buffer.add_string entries_buff (str_of_short tlk.(i).flags) ; 
-     Buffer.add_string entries_buff (str_to_exact_size tlk.(i).sound_name 8) ; 
-     Buffer.add_string entries_buff (str_of_int tlk.(i).volume) ; 
-     Buffer.add_string entries_buff (str_of_int tlk.(i).pitch) ; 
-     Buffer.add_string entries_buff (str_of_int (Buffer.length string_buff)) ;
-     Buffer.add_string entries_buff (str_of_int (String.length tlk.(i).text)) ;
- 
-     Buffer.add_string string_buff tlk.(i).text 
-   done ) () ;
- 
-   Stats.time "saving files" (fun () ->  
-   Buffer.output_buffer outchan header_buff ; 
-   Buffer.output_buffer outchan entries_buff ; 
-   Buffer.output_buffer outchan string_buff ; 
-   close_out outchan) () ;
-   log_and_print "[%s] created, %d string entries\n" filename num ; 
-   () 
- end
- *)
- 
  let lse_to_tlk_string lse = 
    let male = {
!     flags = flags_parse ;
      sound_name = lse.lse_male_sound ;
      volume = 0; 
      pitch = 0;
      text = lse.lse_male;
    } in
    let female = {
!     flags = flags_parse ;
      sound_name = lse.lse_female_sound ;
      volume = 0; 
      pitch = 0;
      text = lse.lse_female;
    } in
!   male, female
--- 276,302 ----
    () 
  end
  
  let lse_to_tlk_string lse =
    let male = {
!     flags = 0 ;
      sound_name = lse.lse_male_sound ;
      volume = 0;
      pitch = 0;
      text = lse.lse_male;
    } in
    let female = {
!     flags = 0 ;
      sound_name = lse.lse_female_sound ;
      volume = 0;
      pitch = 0;
      text = lse.lse_female;
    } in
!   let apply_flags x =
! 	  {x with flags = match x.sound_name, x.text, !is_bg2 with
! 			| "", "", _ -> 0
! 			| _, "", _ -> 2
! 			| _, _, false -> 3
! 			| _, _, true -> (try ignore (String.index x.text '<'); 7 with _ -> 3)
! 	}  in
! 	let apply_flags x = {x with flags = 7 } in
! 	apply_flags male, apply_flags female
