*** WeiDU-185/zlib/zconf.h	Fri Sep 27 03:16:30 2002
--- WeiDU/zlib/zconf.h	Sat Sep  1 02:42:04 2007
***************
*** 1,88 ****
  /* zconf.h -- configuration of the zlib compression library
!  * Copyright (C) 1995-1998 Jean-loup Gailly.
   * For conditions of distribution and use, see copyright notice in zlib.h 
   */
  
  /* @(#) $Id$ */
  
! #ifndef _ZCONF_H
! #define _ZCONF_H
  
  /*
   * If you *really* need a unique prefix for all types and library functions,
   * compile with -DZ_PREFIX. The "standard" zlib should be compiled without it.
   */
! #ifdef Z_PREFIX
! #  define deflateInit_	z_deflateInit_
  #  define deflate	z_deflate
  #  define deflateEnd	z_deflateEnd
- #  define inflateInit_ 	z_inflateInit_
- #  define inflate	z_inflate
- #  define inflateEnd	z_inflateEnd
  #  define deflateInit2_	z_deflateInit2_
! #  define deflateSetDictionary z_deflateSetDictionary
! #  define deflateCopy	z_deflateCopy
! #  define deflateReset	z_deflateReset
  #  define deflateParams	z_deflateParams
  #  define inflateInit2_	z_inflateInit2_
  #  define inflateSetDictionary z_inflateSetDictionary
  #  define inflateSync	z_inflateSync
  #  define inflateSyncPoint z_inflateSyncPoint
! #  define inflateReset	z_inflateReset
! #  define compress	z_compress
! #  define compress2	z_compress2
  #  define uncompress	z_uncompress
! #  define adler32	z_adler32
! #  define crc32		z_crc32
! #  define get_crc_table z_get_crc_table
  
  #  define Byte		z_Byte
- #  define uInt		z_uInt
- #  define uLong		z_uLong
  #  define Bytef	        z_Bytef
  #  define charf		z_charf
  #  define intf		z_intf
  #  define uIntf		z_uIntf
  #  define uLongf	z_uLongf
- #  define voidpf	z_voidpf
  #  define voidp		z_voidp
  #endif
  
! #if (defined(_WIN32) || defined(__WIN32__)) && !defined(WIN32)
  #  define WIN32
  #endif
! #if defined(__GNUC__) || defined(WIN32) || defined(__386__) || defined(i386)
! #  ifndef __32BIT__
! #    define __32BIT__
  #  endif
  #endif
- #if defined(__MSDOS__) && !defined(MSDOS)
- #  define MSDOS
  #endif
  
  /*
   * Compile with -DMAXSEG_64K if the alloc function cannot allocate more
   * than 64k bytes at a time (needed on systems with 16-bit int).
   */
! #if defined(MSDOS) && !defined(__32BIT__)
  #  define MAXSEG_64K
  #endif
  #ifdef MSDOS
  #  define UNALIGNED_OK
  #endif
  
! #if (defined(MSDOS) || defined(_WINDOWS) || defined(WIN32))  && !defined(STDC)
  #  define STDC
  #endif
! #if defined(__STDC__) || defined(__cplusplus) || defined(__OS2__)
! #  ifndef STDC
  #    define STDC
  #  endif
  #endif
  
  #ifndef STDC
  #  ifndef const /* cannot use !defined(STDC) && !defined(const) on Mac */
! #    define const
  #  endif
  #endif
  
--- 1,190 ----
  /* zconf.h -- configuration of the zlib compression library
!  * Copyright (C) 1995-2006 Jean-loup Gailly.
   * For conditions of distribution and use, see copyright notice in zlib.h
   */
  
  /* @(#) $Id$ */
  
! #ifndef ZCONF_H
! #define ZCONF_H
  
  /*
   * If you *really* need a unique prefix for all types and library functions,
   * compile with -DZ_PREFIX. The "standard" zlib should be compiled without it.
+  * Even better than compiling with -DZ_PREFIX would be to use configure to set
+  * this permanently in zconf.h using "./configure --zprefix".
   */
! #ifdef Z_PREFIX     /* may be set to #if 1 by ./configure */
! 
! /* all linked symbols */
! #  define _dist_code            z__dist_code
! #  define _length_code          z__length_code
! #  define _tr_align             z__tr_align
! #  define _tr_flush_block       z__tr_flush_block
! #  define _tr_init              z__tr_init
! #  define _tr_stored_block      z__tr_stored_block
! #  define _tr_tally             z__tr_tally
! #  define adler32               z_adler32
! #  define adler32_combine       z_adler32_combine
! #  define compress              z_compress
! #  define compress2             z_compress2
! #  define compressBound         z_compressBound
! #  define crc32                 z_crc32
! #  define crc32_combine         z_crc32_combine
  #  define deflate               z_deflate
+ #  define deflateBound          z_deflateBound
+ #  define deflateCopy           z_deflateCopy
  #  define deflateEnd            z_deflateEnd
  #  define deflateInit2_         z_deflateInit2_
! #  define deflateInit_          z_deflateInit_
  #  define deflateParams         z_deflateParams
+ #  define deflatePrime          z_deflatePrime
+ #  define deflateReset          z_deflateReset
+ #  define deflateSetDictionary  z_deflateSetDictionary
+ #  define deflateSetHeader      z_deflateSetHeader
+ #  define deflateTune           z_deflateTune
+ #  define deflate_copyright     z_deflate_copyright
+ #  define get_crc_table         z_get_crc_table
+ #  define gzclearerr            z_gzclearerr
+ #  define gzclose               z_gzclose
+ #  define gzdirect              z_gzdirect
+ #  define gzdopen               z_gzdopen
+ #  define gzeof                 z_gzeof
+ #  define gzerror               z_gzerror
+ #  define gzflush               z_gzflush
+ #  define gzgetc                z_gzgetc
+ #  define gzgets                z_gzgets
+ #  define gzopen                z_gzopen
+ #  define gzprintf              z_gzprintf
+ #  define gzputc                z_gzputc
+ #  define gzputs                z_gzputs
+ #  define gzread                z_gzread
+ #  define gzrewind              z_gzrewind
+ #  define gzseek                z_gzseek
+ #  define gzsetparams           z_gzsetparams
+ #  define gztell                z_gztell
+ #  define gzungetc              z_gzungetc
+ #  define gzwrite               z_gzwrite
+ #  define inflate               z_inflate
+ #  define inflateBack           z_inflateBack
+ #  define inflateBackEnd        z_inflateBackEnd
+ #  define inflateBackInit_      z_inflateBackInit_
+ #  define inflateCopy           z_inflateCopy
+ #  define inflateEnd            z_inflateEnd
+ #  define inflateGetHeader      z_inflateGetHeader
  #  define inflateInit2_         z_inflateInit2_
+ #  define inflateInit_          z_inflateInit_
+ #  define inflatePrime          z_inflatePrime
+ #  define inflateReset          z_inflateReset
  #  define inflateSetDictionary  z_inflateSetDictionary
  #  define inflateSync           z_inflateSync
  #  define inflateSyncPoint      z_inflateSyncPoint
! #  define inflate_copyright     z_inflate_copyright
! #  define inflate_fast          z_inflate_fast
! #  define inflate_table         z_inflate_table
  #  define uncompress            z_uncompress
! #  define zError                z_zError
! #  define z_errmsg              z_z_errmsg
! #  define zcalloc               z_zcalloc
! #  define zcfree                z_zcfree
! #  define zlibCompileFlags      z_zlibCompileFlags
! #  define zlibVersion           z_zlibVersion
  
+ /* all zlib typedefs in zlib.h and zconf.h */
  #  define Byte                  z_Byte
  #  define Bytef                 z_Bytef
+ #  define alloc_func            z_alloc_func
  #  define charf                 z_charf
+ #  define free_func             z_free_func
+ #  define gzFile                z_gzFile
+ #  define gz_header             z_gz_header
+ #  define gz_headerp            z_gz_headerp
+ #  define in_func               z_in_func
  #  define intf                  z_intf
+ #  define out_func              z_out_func
+ #  define uInt                  z_uInt
  #  define uIntf                 z_uIntf
+ #  define uLong                 z_uLong
  #  define uLongf                z_uLongf
  #  define voidp                 z_voidp
+ #  define voidp                 z_voidp
+ #  define voidpc                z_voidpc
+ #  define voidpc                z_voidpc
+ #  define voidpf                z_voidpf
+ #  define voidpf                z_voidpf
+ #  define z_stream              z_z_stream
+ #  define z_streamp             z_z_streamp
+ 
+ /* all zlib structs in zlib.h and zconf.h */
+ #  define gz_header_s           z_gz_header_s
+ #  define internal_state        z_internal_state
+ #  define z_stream_s            z_z_stream_s
+ 
  #endif
  
! #if defined(__MSDOS__) && !defined(MSDOS)
! #  define MSDOS
! #endif
! #if (defined(OS_2) || defined(__OS2__)) && !defined(OS2)
! #  define OS2
! #endif
! #if defined(_WINDOWS) && !defined(WINDOWS)
! #  define WINDOWS
! #endif
! #if defined(_WIN32) || defined(_WIN32_WCE) || defined(__WIN32__)
! #  ifndef WIN32
  #    define WIN32
  #  endif
! #endif
! #if (defined(MSDOS) || defined(OS2) || defined(WINDOWS)) && !defined(WIN32)
! #  if !defined(__GNUC__) && !defined(__FLAT__) && !defined(__386__)
! #    ifndef SYS16BIT
! #      define SYS16BIT
  #    endif
  #  endif
  #endif
  
  /*
   * Compile with -DMAXSEG_64K if the alloc function cannot allocate more
   * than 64k bytes at a time (needed on systems with 16-bit int).
   */
! #ifdef SYS16BIT
  #  define MAXSEG_64K
  #endif
  #ifdef MSDOS
  #  define UNALIGNED_OK
  #endif
  
! #ifdef __STDC_VERSION__
! #  ifndef STDC
  #    define STDC
  #  endif
! #  if __STDC_VERSION__ >= 199901L
! #    ifndef STDC99
! #      define STDC99
! #    endif
! #  endif
! #endif
! #if !defined(STDC) && (defined(__STDC__) || defined(__cplusplus))
  #  define STDC
  #endif
+ #if !defined(STDC) && (defined(__GNUC__) || defined(__BORLANDC__))
+ #  define STDC
+ #endif
+ #if !defined(STDC) && (defined(MSDOS) || defined(WINDOWS) || defined(WIN32))
+ #  define STDC
+ #endif
+ #if !defined(STDC) && (defined(OS2) || defined(__HOS_AIX__))
+ #  define STDC
+ #endif
+ 
+ #if defined(__OS400__) && !defined(STDC)    /* iSeries (formerly AS/400). */
+ #  define STDC
  #endif
  
  #ifndef STDC
  #  ifndef const /* cannot use !defined(STDC) && !defined(const) on Mac */
! #    define const       /* note: need a more gentle solution here */
  #  endif
  #endif
  
***************
*** 91,105 ****
  #  define NO_DUMMY_DECL
  #endif
  
- /* Old Borland C incorrectly complains about missing returns: */
- #if defined(__BORLANDC__) && (__BORLANDC__ < 0x460)
- #  define NEED_DUMMY_RETURN
- #endif
- #if defined(__TURBOC__) && !defined(__BORLANDC__)
- #  define NEED_DUMMY_RETURN
- #endif
- 
- 
  /* Maximum value for memLevel in deflateInit2 */
  #ifndef MAX_MEM_LEVEL
  #  ifdef MAXSEG_64K
--- 193,198 ----
***************
*** 147,153 ****
   * to define NO_MEMCPY in zutil.h.  If you don't need the mixed model,
   * just define FAR to be empty.
   */
! #if (defined(M_I86SM) || defined(M_I86MM)) && !defined(__32BIT__)
     /* MSC small or medium model */
  #  define SMALL_MEDIUM
  #  ifdef _MSC_VER
--- 240,247 ----
   * to define NO_MEMCPY in zutil.h.  If you don't need the mixed model,
   * just define FAR to be empty.
   */
! #ifdef SYS16BIT
! #  if defined(M_I86SM) || defined(M_I86MM)
       /* MSC small or medium model */
  #    define SMALL_MEDIUM
  #    ifdef _MSC_VER
***************
*** 156,226 ****
  #    define FAR far
  #  endif
  #endif
! #if defined(__BORLANDC__) && (defined(__SMALL__) || defined(__MEDIUM__))
! #  ifndef __32BIT__
  #    define SMALL_MEDIUM
  #    define FAR _far
  #  endif
  #endif
- 
- #if defined(WIN32) && (!defined(ZLIB_WIN32_NODLL)) && (!defined(ZLIB_DLL))
- #  define ZLIB_DLL
  #endif
  
! /* Compile with -DZLIB_DLL for Windows DLL support */
! #if defined(ZLIB_DLL)
! #  if defined(_WINDOWS) || defined(WINDOWS) || defined(WIN32)
! #    ifndef WINAPI
  #      ifdef FAR
  #        undef FAR
  #      endif
  #      include <windows.h>
! #    endif
! #    ifdef WIN32
  #      define ZEXPORT  WINAPI
  #      define ZEXPORTVA  WINAPIV
  #    else
! #      define ZEXPORT  WINAPI _export
! #      define ZEXPORTVA  FAR _cdecl _export
! #    endif
! #  endif
! #  if defined (__BORLANDC__)
! #    if (__BORLANDC__ >= 0x0500) && defined (WIN32)
! #      include <windows.h>
! #      define ZEXPORT __declspec(dllexport) WINAPI
! #      define ZEXPORTVA __declspec(dllexport) WINAPIV
! #    else
! #      if defined (_Windows) && defined (__DLL__)
! #        define ZEXPORT _export
! #        define ZEXPORTVA _export
! #      endif
  #    endif
  #  endif
  #endif
  
  #if defined (__BEOS__)
! #  if defined (ZLIB_DLL)
! #    define ZEXTERN extern __declspec(dllexport)
  #  else
! #    define ZEXTERN extern __declspec(dllimport)
  #  endif
  #endif
  
  #ifndef ZEXPORT
  #  define ZEXPORT
  #endif
  #ifndef ZEXPORTVA
  #  define ZEXPORTVA
  #endif
- #ifndef ZEXTERN
- #  define ZEXTERN extern
- #endif
  
  #ifndef FAR
  #   define FAR
  #endif
  
! #if !defined(MACOS) && !defined(TARGET_OS_MAC)
  typedef unsigned char  Byte;  /* 8 bits */
  #endif
  typedef unsigned int   uInt;  /* 16 bits or more */
--- 250,330 ----
  #      define FAR far
  #    endif
  #  endif
! #  if (defined(__SMALL__) || defined(__MEDIUM__))
!      /* Turbo C small or medium model */
  #    define SMALL_MEDIUM
+ #    ifdef __BORLANDC__
  #      define FAR _far
+ #    else
+ #      define FAR far
  #    endif
  #  endif
  #endif
  
! #if defined(WINDOWS) || defined(WIN32)
!    /* If building or using zlib as a DLL, define ZLIB_DLL.
!     * This is not mandatory, but it offers a little performance increase.
!     */
! #  ifdef ZLIB_DLL
! #    if defined(WIN32) && (!defined(__BORLANDC__) || (__BORLANDC__ >= 0x500))
! #      ifdef ZLIB_INTERNAL
! #        define ZEXTERN extern __declspec(dllexport)
! #      else
! #        define ZEXTERN extern __declspec(dllimport)
! #      endif
! #    endif
! #  endif  /* ZLIB_DLL */
!    /* If building or using zlib with the WINAPI/WINAPIV calling convention,
!     * define ZLIB_WINAPI.
!     * Caution: the standard ZLIB1.DLL is NOT compiled using ZLIB_WINAPI.
!     */
! #  ifdef ZLIB_WINAPI
  #    ifdef FAR
  #      undef FAR
  #    endif
  #    include <windows.h>
!      /* No need for _export, use ZLIB.DEF instead. */
!      /* For complete Windows compatibility, use WINAPI, not __stdcall. */
  #    define ZEXPORT WINAPI
+ #    ifdef WIN32
  #      define ZEXPORTVA WINAPIV
  #    else
! #      define ZEXPORTVA FAR CDECL
  #    endif
  #  endif
  #endif
  
  #if defined (__BEOS__)
! #  ifdef ZLIB_DLL
! #    ifdef ZLIB_INTERNAL
! #      define ZEXPORT   __declspec(dllexport)
! #      define ZEXPORTVA __declspec(dllexport)
  #    else
! #      define ZEXPORT   __declspec(dllimport)
! #      define ZEXPORTVA __declspec(dllimport)
! #    endif
! #  endif
  #endif
+ 
+ #ifdef HAVE_VISIBILITY_PRAGMA
+ #  define ZEXTERN __attribute__((visibility ("default"))) extern
  #endif
  
+ #ifndef ZEXTERN
+ #  define ZEXTERN extern
+ #endif
  #ifndef ZEXPORT
  #  define ZEXPORT
  #endif
  #ifndef ZEXPORTVA
  #  define ZEXPORTVA
  #endif
  
  #ifndef FAR
  #  define FAR
  #endif
  
! #if !defined(__MACTYPES__)
  typedef unsigned char  Byte;  /* 8 bits */
  #endif
  typedef unsigned int   uInt;  /* 16 bits or more */
***************
*** 238,258 ****
  typedef uLong FAR uLongf;
  
  #ifdef STDC
     typedef void FAR *voidpf;
     typedef void     *voidp;
  #else
     typedef Byte FAR *voidpf;
     typedef Byte     *voidp;
  #endif
  
! #ifdef HAVE_UNISTD_H
! #  include <sys/types.h> /* for off_t */
! #  include <unistd.h>    /* for SEEK_* and off_t */
! #  ifdef VMS
! #    include <unixio.h>   /* for off_t */
! #  endif
! #  define z_off_t  off_t
! #endif
  #ifndef SEEK_SET
  #  define SEEK_SET        0       /* Seek from beginning of file.  */
  #  define SEEK_CUR        1       /* Seek from current position.  */
--- 342,358 ----
  typedef uLong FAR uLongf;
  
  #ifdef STDC
+    typedef void const *voidpc;
     typedef void FAR   *voidpf;
     typedef void       *voidp;
  #else
+    typedef Byte const *voidpc;
     typedef Byte FAR   *voidpf;
     typedef Byte       *voidp;
  #endif
  
! #include "zlibdefs.h"       /* created by configure */
! 
  #ifndef SEEK_SET
  #  define SEEK_SET        0       /* Seek from beginning of file.  */
  #  define SEEK_CUR        1       /* Seek from current position.  */
***************
*** 262,292 ****
  #  define  z_off_t long
  #endif
  
  /* MVS linker does not support external names larger than 8 bytes */
  #if defined(__MVS__)
  #   pragma map(deflateInit_,"DEIN")
  #   pragma map(deflateInit2_,"DEIN2")
  #   pragma map(deflateEnd,"DEEND")
  #   pragma map(inflateInit_,"ININ")
  #   pragma map(inflateInit2_,"ININ2")
  #   pragma map(inflateEnd,"INEND")
  #   pragma map(inflateSync,"INSY")
  #   pragma map(inflateSetDictionary,"INSEDI")
! #   pragma map(inflate_blocks,"INBL")
! #   pragma map(inflate_blocks_new,"INBLNE")
! #   pragma map(inflate_blocks_free,"INBLFR")
! #   pragma map(inflate_blocks_reset,"INBLRE")
! #   pragma map(inflate_codes_free,"INCOFR")
! #   pragma map(inflate_codes,"INCO")
  #   pragma map(inflate_fast,"INFA")
- #   pragma map(inflate_flush,"INFLU")
- #   pragma map(inflate_mask,"INMA")
- #   pragma map(inflate_set_dictionary,"INSEDI2")
  #   pragma map(inflate_copyright,"INCOPY")
- #   pragma map(inflate_trees_bits,"INTRBI")
- #   pragma map(inflate_trees_dynamic,"INTRDY")
- #   pragma map(inflate_trees_fixed,"INTRFI")
- #   pragma map(inflate_trees_free,"INTRFR")
  #endif
  
! #endif /* _ZCONF_H */
--- 362,390 ----
  #  define z_off_t long
  #endif
  
+ #if defined(__OS400__)
+ #  define NO_vsnprintf
+ #endif
+ 
+ #if defined(__MVS__)
+ #  define NO_vsnprintf
+ #endif
+ 
  /* MVS linker does not support external names larger than 8 bytes */
  #if defined(__MVS__)
  #   pragma map(deflateInit_,"DEIN")
  #   pragma map(deflateInit2_,"DEIN2")
  #   pragma map(deflateEnd,"DEEND")
+ #   pragma map(deflateBound,"DEBND")
  #   pragma map(inflateInit_,"ININ")
  #   pragma map(inflateInit2_,"ININ2")
  #   pragma map(inflateEnd,"INEND")
  #   pragma map(inflateSync,"INSY")
  #   pragma map(inflateSetDictionary,"INSEDI")
! #   pragma map(compressBound,"CMBND")
! #   pragma map(inflate_table,"INTABL")
  #   pragma map(inflate_fast,"INFA")
  #   pragma map(inflate_copyright,"INCOPY")
  #endif
  
! #endif /* ZCONF_H */
